#include <gtk/gtk.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include "configfile.h"
#include <string.h>

gboolean titleshow[33];
const gchar *title[]={"","Ա","","","","","Ф","","س","ǳ","ʼ","","ʼ2","ƶ绰","Զ","ICQ","ҳ","","ַͥ","ʱ","Ա","ͥ绰","Զ","","ַ","ʱ","ҳ","","绰","","ְλ","վ̨","ע"};

ConfigFile *rccfgfile;

void create_yqfile(gchar *filename);

void
yqrc_init()
{
        gchar yq_dir[256];
        gchar yqrc_file[256];        
        gchar yq_file[256];        
	gchar *home;
	struct stat st;
	FILE *file;
	gint i;
	gboolean ifshow;

	if ((home = getenv("HOME")) == NULL) return;

	strcpy(yq_dir, home);
	if (yq_dir[strlen(yq_dir) - 1] != '/') strcat(yq_dir, "/");

	strcpy(yqrc_file, yq_dir);
	strcat(yqrc_file, ".yqrc");
	sprintf(yq_file,"1=%syqfile\n",yq_dir);
	if (stat(yqrc_file, &st))
	{
		if ((file = fopen(yqrc_file, "w")) == NULL) return;
		fprintf(file, "[setting]\n");
		fprintf(file, "paned_position=124\n");
		fprintf(file, "window_width=640\n");	 	 
		fprintf(file, "window_height=430\n");
		fprintf(file, "[file]\n");
		fprintf(file, "a=1\n");
		fprintf(file, yq_file);
		fprintf(file, "[title]\n");
		for (i=1;i<=33;i++)
		{
			sprintf(yq_file,"%d=%s\n",i,title[i-1]);
			fprintf(file,yq_file);
		}
		fprintf(file, "[titleshow]\n");
		for (i=1;i<=33;i++)
		{
			if ((i==1)||(i==10)||(i==11)||(i==16)||(i==17)||(i==22)||(i==33))
			ifshow=1;else ifshow=0;
			sprintf(yq_file,"%d=%d\n",i,ifshow);
			fprintf(file,yq_file);
		}
		fprintf(file, "[titlewidth]\n");
		for (i=1;i<=33;i++)
		{
			sprintf(yq_file,"%d=%d\n",i,0);
			fprintf(file,yq_file);
		}
		
		fclose(file);
	} 
	sprintf(yq_file,"%syqfile",yq_dir);
	if (stat(yq_file, &st))
		create_yqfile(yq_file);
        rccfgfile=yq_cfg_open_file(yqrc_file);
        
        for (i=1;i<=33;i++)        	
        {
        	sprintf(yq_file,"%d",i);
        	yq_cfg_read_boolean(rccfgfile,"titleshow",yq_file,&titleshow[i-1]);
        }
}

void
create_yqfile(gchar *filename)
{
	FILE *file;

	if ((file = fopen(filename, "w")) == NULL)	return;
	fprintf(file, "[yq]\n");
	fprintf(file, "z=0\n");
	fprintf(file, "a=0\n");
	fprintf(file, "n=ҵļ¼\n");
	fclose(file);
}
