#include "yqtype.h"
#include <gtk/gtk.h>
#include "configfile.h"


extern ConfigFile *rccfgfile;
extern gchar tree_selectzuname[255];


GtkWidget *tree_main,*treewin,*root_leaf;

GtkWidget* yq_createleaf(gchar *ab,ImageType ed);
void rootleaf_select();
void rootleaf_collapse();
static void treewin_size_changed(GtkWidget *box);
void yq_set_list_type(ListType type);


static void
treewin_size_changed(GtkWidget *box)
{
	yq_cfg_write_int(rccfgfile,"setting","paned_position",box->allocation.width); 
}

void
rootleaf_select()
{
tree_selectzuname[0]='\0';
yq_set_list_type(LIST_DETAILS);
}

void
rootleaf_collapse()
{
if (tree_selectzuname[0]=='\0') return;
gtk_tree_select_child(GTK_TREE(tree_main)->root_tree,root_leaf);
}


void
createtree(GtkWidget *parent,GtkWidget *vbox)
{
 GtkWidget *tree;
 
 tree=gtk_tree_new();
  
 root_leaf=yq_createleaf("¼",YQFILE);
 gtk_signal_connect(GTK_OBJECT(root_leaf), "select",
			GTK_SIGNAL_FUNC(rootleaf_select),NULL);
 gtk_signal_connect(GTK_OBJECT(root_leaf), "collapse",
			GTK_SIGNAL_FUNC(rootleaf_collapse),NULL);
 gtk_tree_append(GTK_TREE(tree),root_leaf);
 gtk_widget_show (tree); 
 tree_main=gtk_tree_new();
 gtk_tree_item_set_subtree(GTK_TREE_ITEM(root_leaf),tree_main);
 gtk_widget_show(tree_main); 
 gtk_tree_item_expand(GTK_TREE_ITEM(root_leaf));
 treewin = gtk_scrolled_window_new(NULL, NULL);
 gtk_signal_connect_object(
		GTK_OBJECT(treewin),
		"size_allocate",
		GTK_SIGNAL_FUNC(treewin_size_changed),
		GTK_OBJECT(treewin));
 gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(treewin),
	GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(treewin), tree);
 gtk_box_pack_start(GTK_BOX (vbox),treewin, TRUE, TRUE, 0);
 gtk_widget_show(treewin);
}
