#include "configfile.h"
#include <gtk/gtk.h>
#include <string.h>
#include "yqtype.h"
#include "treenode.h"
#include <sys/stat.h>
#include <stdio.h>


extern gchar sFilename[256]; 
extern gint yesnoreturn;
extern ConfigFile *cfgfile;
extern gboolean tree_selectiszu;
extern gint clist_selectrow;
extern gchar tree_selectzuname[255],tree_selectjilu[4];
extern struct _YQList yqlist;
extern GtkWidget *new_button, *open_button,*print_button, *cut_button, *copy_button, *paste_button, *search_button, *add_button, *remove_button, *save_button, *saveadd_button, *cancel_button, *caxun_button,*zu_button,*rename_button,*suxin_button, *bigico_button, *smallico_button, *list_button, *xian_button, *fenye_button, *mima_button, *laji_button, *wannanli_button, *telepho_button, *question_button, *up_button, *down_button;
extern GtkWidget *treewin,*tree_selectitem,*tree_selectrootleaf;
extern GtkTree *tree_selecttree,*tree_selectuptree;
extern GtkWidget
*nb_1_1,*nb_1_2,*nb_1_3,*nb_1_4,*nb_1_5,*nb_1_6,*nb_1_7,*nb_1_8,*nb_1_9,*nb_1_10,*nb_1_11,*nb_1_12,*nb_1_13,*nb_1_14,*nb_1_15,*nb_1_16,*nb_1_17,*nb_1_18,*nb_2_1,*nb_2_2,*nb_2_3,*nb_2_4,*nb_2_5,*nb_2_6,*nb_2_7,*nb_2_8,*nb_2_9,*nb_2_10,*nb_2_11,*nb_2_12,*nb_2_13,*nb_3_1,*nb_3_2;
extern GtkWidget *menu_file_new,*menu_file_open,*menu_file_openold,*menu_file_close,*menu_file_saveas,*menu_file_exit,*menu_edit_cut,*menu_edit_copy,*menu_edit_paste,*menu_jilu_add,*menu_jilu_remove,*menu_jilu_save,*menu_jilu_saveadd,*menu_jilu_cancel,*menu_jilu_zu,*menu_jilu_rename,*menu_tool_option;


gboolean nb_changed,nb_isadd;
struct _Nowincopy nowincopy;


void addtotext(gchar **a,gchar *b);
void nb_setchanged (GtkWidget *widget, gpointer data);
void leaf_setnb(gchar *ab);
void Popup (gchar *szMessage);
void Areyousure (gchar *szMessage);
void YesNo (gchar *szMessage);
void tree_set_pixmap(GtkTreeItem *treeitem,ImageType ed);
void tree_set_text(GtkTreeItem *treeitem, gchar *ab);
GtkWidget* yq_createleaf(gchar *ab,ImageType ed);
gchar *leaf_formattext(gchar *bd);
void leaf_selected (GtkWidget *widget, tree_node *tnode);
void toolbar_save(GtkWidget *widget, gpointer data);
void toolbar_add(GtkWidget *widget, gpointer data);
void zu_expanded(GtkWidget *widget, tree_node *tnode);
void zu_collapsed(GtkWidget *widget, tree_node *tnode);
void zu_selected (GtkWidget *widget, tree_node *tnode);
void yq_cfg_remove_sections(ConfigFile *cfg,gchar *section);
void yq_cfg_rename_sections(ConfigFile *cfg,gchar *section,gchar *section_name);
void yq_cfg_daiti_sections(ConfigFile *cfg,gchar *section1,gchar *section2);
GtkWidget *yq_readzu(tree_node *tnode);
GtkWidget  *yq_createnulltree();
void yq_readfile(GtkWidget *widget, gpointer openfile);
void GetFilename (char *sTitle);
void InputName (gchar *szMessage,gchar *entryvalue);
void create_yqfile(gchar *filename);
void open_zu(gchar *zuname);
void toolbar_addjilu(gchar *ab);
void toolbar_addzu();
void toolbar_copyzu(gchar *zuname1,gchar *zuname2);




GtkWidget 
*yq_createnulltree()
{
GtkWidget *tree;
 tree=gtk_tree_new();
 gtk_widget_show (tree);
 return tree;
}

void
yq_cfg_remove_sections(ConfigFile *cfg,gchar *section)
{
gint i,z;
gchar tz[260];
yq_cfg_read_int(cfg,section,"z",&z);
for (i=1;i<=z;i++)
 {
 sprintf(tz,"%s_%d",section,i);
 yq_cfg_remove_sections(cfg,tz);
 } 
yq_cfg_remove_section(cfg,section);
}

void yq_cfg_daiti_sections(ConfigFile *cfg,gchar *section1,gchar *section2)
{
yq_cfg_remove_sections(cfg,section1);
yq_cfg_rename_sections(cfg,section2,section1);
}

void yq_cfg_rename_sections(ConfigFile *cfg,gchar *section,gchar *section_name)
{
gint i,z;
gchar tz1[260],tz2[260];
yq_cfg_read_int(cfg,section,"z",&z);
for (i=1;i<=z;i++)
 {
 sprintf(tz1,"%s_%d",section,i);
 sprintf(tz2,"%s_%d",section_name,i);
 yq_cfg_rename_sections(cfg,tz1,tz2); 
 }
 yq_cfg_rename_section(cfg,section,section_name); 
}



void
nb_setchanged (GtkWidget *widget, gpointer data)
{
if ((widget!=save_button)==nb_changed) return;

gtk_widget_set_sensitive(new_button,nb_changed);
gtk_widget_set_sensitive(menu_file_new,nb_changed);
gtk_widget_set_sensitive(open_button,nb_changed);
gtk_widget_set_sensitive(menu_file_open,nb_changed);
gtk_widget_set_sensitive(menu_file_openold,nb_changed);
gtk_widget_set_sensitive(menu_file_close,nb_changed);
gtk_widget_set_sensitive(menu_file_saveas,nb_changed);
gtk_widget_set_sensitive(print_button,nb_changed);
gtk_widget_set_sensitive(cut_button,nb_changed);
gtk_widget_set_sensitive(copy_button,nb_changed);
gtk_widget_set_sensitive(menu_edit_copy,nb_changed);
gtk_widget_set_sensitive(paste_button,nb_changed);
gtk_widget_set_sensitive(menu_edit_paste,nb_changed);
gtk_widget_set_sensitive(search_button,nb_changed);
gtk_widget_set_sensitive(add_button,nb_changed);
gtk_widget_set_sensitive(menu_jilu_add,nb_changed);
gtk_widget_set_sensitive(remove_button,nb_changed);
gtk_widget_set_sensitive(menu_jilu_remove,nb_changed);
gtk_widget_set_sensitive(zu_button,nb_changed);
gtk_widget_set_sensitive(menu_jilu_zu,nb_changed);
gtk_widget_set_sensitive(rename_button,nb_changed);
gtk_widget_set_sensitive(menu_jilu_rename,nb_changed);
gtk_widget_set_sensitive(suxin_button,nb_changed);
gtk_widget_set_sensitive(caxun_button,nb_changed);
gtk_widget_set_sensitive(bigico_button,nb_changed);
gtk_widget_set_sensitive(smallico_button,nb_changed);
gtk_widget_set_sensitive(list_button,nb_changed);
gtk_widget_set_sensitive(xian_button,nb_changed);
gtk_widget_set_sensitive(fenye_button,nb_changed);
gtk_widget_set_sensitive(mima_button,nb_changed);
gtk_widget_set_sensitive(laji_button,nb_changed);
gtk_widget_set_sensitive(up_button,nb_changed);
gtk_widget_set_sensitive(down_button,nb_changed);


gtk_widget_set_sensitive(treewin,nb_changed);

nb_changed=!nb_changed;  
gtk_widget_set_sensitive(menu_jilu_save,nb_changed);
gtk_widget_set_sensitive(menu_jilu_saveadd,nb_changed);
gtk_widget_set_sensitive(menu_jilu_cancel,nb_changed);                       
gtk_widget_set_sensitive(save_button,nb_changed);
gtk_widget_set_sensitive(saveadd_button,nb_changed);
gtk_widget_set_sensitive(cancel_button,nb_changed);       
}

void
addtotext(gchar **a,gchar *bb)
{
gint i;
gchar *b;
if (*bb=='\0')
 {
   **a='~';(*a)++;**a='0';(*a)++;
 }
else
 {   
  b=bb;
  for (i=1;i<=strlen(bb);i++)
   {
   switch (*b)
           {
           case '~':
              **a='~';(*a)++;**a='~';break;              
           case '\n':
              **a='~';(*a)++;**a='n';break;
           case ',':
              **a='~';(*a)++;**a='d';break;  
           default:
              **a=*b;break;
            }
     (*a)++;
     b++;
    }                        
 }  
  **a=',';
  (*a)++;
}

void
toolbar_save(GtkWidget *widget, gpointer data)
{
	gchar *ab,*a,bb[260],*c;

	if (*gtk_entry_get_text(GTK_ENTRY(nb_1_1))=='\0')
	{
		Popup(""); 
		return;    
	}
	ab=g_malloc(10000);
	a=ab;
	c=gtk_entry_get_text(GTK_ENTRY(nb_1_1));
	if (!nb_isadd) tree_set_text(GTK_TREE_ITEM(tree_selectitem),c);
	addtotext(&a,c);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY (GTK_COMBO(nb_1_2)->entry)),""))
	{
		strcpy(bb,"1");
		if (!nb_isadd) tree_set_pixmap(GTK_TREE_ITEM(tree_selectitem),BOY);
	} else
	{
		strcpy(bb,"0");
		if (!nb_isadd) tree_set_pixmap(GTK_TREE_ITEM(tree_selectitem),GIRL);
	}
	addtotext(&a,bb);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY (GTK_COMBO(nb_1_3)->entry)),""))
		strcpy(bb,"1");
	else
		strcpy(bb,"0");
	addtotext(&a,bb);
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_5)));
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(nb_1_4)))
	strcpy(bb,"1");else strcpy(bb,"0");
	addtotext(&a,bb);
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_6)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_7)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_8)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_9)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_10)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_11)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_12)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_13)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_14)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_15)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_16)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_17)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_18)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_1)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_2)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_3)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_4)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_5)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_6)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_7)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_8)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_9)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_10)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_11)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_12)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_13)));
	c=gtk_editable_get_chars(GTK_EDITABLE(nb_3_1),(gint)0,(gint)-1);
	addtotext(&a,c);
	g_free(c);
	c=gtk_editable_get_chars(GTK_EDITABLE(nb_3_2),(gint)0,(gint)-1);
	addtotext(&a,c);
	g_free(c);
	a--;
	*a='\0';
	nb_setchanged(save_button,NULL);
	if (!nb_isadd)
		yq_cfg_write_string(cfgfile,tree_selectzuname,tree_selectjilu,ab);
	else
		toolbar_addjilu(ab);
	g_free(ab);
}

void 
toolbar_addjilu(gchar *ab)
{
	GtkWidget *leaf;
	gchar bb[260],*a;
	gint i,n;
	tree_node *tnode;

		a=strchr(ab,',');
		*a='\0';
		strcpy(bb,ab);
		leaf_formattext(bb);
		*a=',';
		if (*(a+1)=='1')
			leaf=yq_createleaf(bb,BOY);
		else
			leaf=yq_createleaf(bb,GIRL);

		tnode = g_malloc(sizeof(tree_node));
		tnode -> cfg = cfgfile;
		if (tree_selectiszu)
		{
			if  (!GTK_TREE_ITEM(tree_selectitem)->subtree) 
				gtk_tree_item_set_subtree(GTK_TREE_ITEM(tree_selectitem),yq_createnulltree());
			if (!GTK_TREE_ITEM(tree_selectitem)->expanded)
				gtk_tree_item_expand(GTK_TREE_ITEM(tree_selectitem));
			gtk_tree_append(GTK_TREE(GTK_TREE_ITEM(tree_selectitem)->subtree),leaf);
			tnode->attree=GTK_TREE(GTK_TREE_ITEM(tree_selectitem)->subtree);
			tnode->uptree=tree_selecttree;
		}
		else
		{
			gtk_tree_append(tree_selecttree,leaf);
			tnode->attree=tree_selecttree;
			tnode->uptree=tree_selectuptree;
		}
		yq_cfg_read_int(cfgfile,tree_selectzuname,"a",&i);
		i++;
		sprintf(bb,"%s-%d",tree_selectzuname,i);
		tnode->root_leaf=tree_selectrootleaf;
		strcpy(tnode -> nodename, bb);
		gtk_signal_connect(GTK_OBJECT(leaf), "select",
			GTK_SIGNAL_FUNC(leaf_selected),tnode);
		sprintf(bb,"%d",i);			
		yq_cfg_write_string(cfgfile,tree_selectzuname,bb,ab);
		yq_cfg_write_int(cfgfile,tree_selectzuname,"a",i);
		nb_isadd=0;    			
		yq_cfg_read_int(cfgfile,tree_selectzuname,"z",&n);
		n=i+n-1;
		if (tree_selectiszu)
			gtk_tree_select_item(GTK_TREE(GTK_TREE_ITEM(tree_selectitem)->subtree),n);
		else
			gtk_tree_select_item(tree_selecttree,n);
}

void
toolbar_saveadd(GtkWidget *widget, gpointer data)
{
toolbar_save(save_button,NULL);
toolbar_add(add_button,NULL);
}


void
toolbar_cancel(GtkWidget *widget, gpointer data)
{
gchar *ab;
if (tree_selectiszu)
   {
       open_zu(tree_selectzuname);
       gtk_clist_select_row(GTK_CLIST(yqlist.list),clist_selectrow,0);
    }   
else
 { 
 yq_cfg_read_string(cfgfile,tree_selectzuname,tree_selectjilu,&ab);
 leaf_setnb(ab);
 g_free(ab);
 }
 nb_setchanged(save_button,NULL);
 nb_isadd=0;
}
/*
void
toolbar_remove_jilu()
{
*/

void
toolbar_remove(GtkWidget *widget, gpointer data)
{
	gint i,n,j,z,k;
	gchar *ab,ti[4],tj[4],tz[260],*bb;
	GtkWidget *leaf;
	GList *children;
	tree_node *tnode;
   
	if (tree_selectzuname[0]=='\0') return;
	if (!tree_selectiszu) 
	{
		j=atoi(tree_selectjilu);		
		yq_cfg_read_int(cfgfile,tree_selectzuname,"z",&z);
		yq_cfg_read_int(cfgfile,tree_selectzuname,"a",&n);	
		for (i=j;i<n;i++)
		{
			sprintf(ti,"%d",i);
			sprintf(tj,"%d",i+1);
			yq_cfg_read_string(cfgfile,tree_selectzuname,tj,&ab);
			yq_cfg_write_string(cfgfile,tree_selectzuname,ti,ab);
			bb=strchr(ab,',');
			*bb='\0';
			if (*(bb+1)=='1')
				leaf=yq_createleaf(leaf_formattext(ab),BOY);
			else
				leaf=yq_createleaf(leaf_formattext(ab),GIRL);    
			gtk_tree_append(GTK_TREE(tree_selecttree),leaf);
			g_free(ab);
			sprintf(tz,"%s-%s",tree_selectzuname,ti);
			tnode = g_malloc(sizeof(tree_node));
			tnode -> cfg = cfgfile;
			tnode->attree=GTK_TREE(tree_selecttree);
			tnode->uptree=GTK_TREE(tree_selectuptree);
			tnode->root_leaf=tree_selectrootleaf;
			strcpy(tnode -> nodename, tz);
			gtk_signal_connect(GTK_OBJECT(leaf), "select",
			GTK_SIGNAL_FUNC(leaf_selected),tnode);
		}
		if (j==n)
			gtk_tree_clear_items(tree_selecttree,z+j-1,-1);
		else
			gtk_tree_clear_items(tree_selecttree,z+j-1,z+n-1);
		yq_cfg_write_int(cfgfile,tree_selectzuname,"a",n-1);  
		sprintf(tj,"%d",n);
		yq_cfg_remove_key(cfgfile,tree_selectzuname,tj);
		if (j==n) j--;
		k=z+j-1;
	}
	else
	{ 
		bb=strrchr(tree_selectzuname,'_');
		if (!bb) return;
		yq_cfg_read_string(cfgfile,tree_selectzuname,"n",&ab);
		sprintf(tz,"ȷʵҪɾ \"%s\" ?",ab);
		g_free(ab);
		Areyousure(tz);
		if (!yesnoreturn) return;
		*bb='\0';
		yq_cfg_read_int(cfgfile,tree_selectzuname,"z",&z);
		yq_cfg_read_int(cfgfile,tree_selectzuname,"a",&n);	
		k=0;
		children = gtk_container_children (GTK_CONTAINER (tree_selecttree));
		while (children) {
			if (children->data==tree_selectitem) break;
			k++;
			children = g_list_remove_link (children, children);
		}	
		if ((k==(z-1))&&(n==0)) k--;
		yq_cfg_write_int(cfgfile,tree_selectzuname,"z",z-1);             
		sprintf(tz,"%s_%d",tree_selectzuname,z);
		*bb='_';
		if (!strcmp(tz,tree_selectzuname))
		{
			yq_cfg_remove_sections(cfgfile,tree_selectzuname); 
			gtk_tree_remove_item(tree_selecttree,tree_selectitem);			
		}
		else
		{
			yq_cfg_daiti_sections(cfgfile,tree_selectzuname,tz);
			gtk_tree_remove_item(tree_selecttree,tree_selectitem);       
			yq_cfg_read_string(cfgfile,tree_selectzuname,"n",&ab);
			leaf=yq_createleaf(ab,ZU_CLOSE);
			g_free(ab);
			tnode = g_malloc(sizeof(tree_node));
			tnode -> cfg = cfgfile;
			tnode->attree=GTK_TREE(tree_selecttree);
			tnode->uptree=GTK_TREE(tree_selectuptree);
			tnode->root_leaf=tree_selectrootleaf;
			strcpy(tnode -> nodename, tree_selectzuname);

			gtk_signal_connect(GTK_OBJECT(leaf), "expand",
				GTK_SIGNAL_FUNC(zu_expanded),tnode);
			gtk_signal_connect(GTK_OBJECT(leaf), "collapse",
				GTK_SIGNAL_FUNC(zu_collapsed),tnode);
			gtk_signal_connect(GTK_OBJECT(leaf), "select",
				GTK_SIGNAL_FUNC(zu_selected),tnode);

			i=0;  
			while (i<(z-1))
			{
				gtk_tree_select_item(tree_selecttree,i);
				if (!strcmp(tree_selectzuname,tz)) {j=i;break;}
				i++;
			}
			gtk_tree_insert(GTK_TREE(tree_selecttree),leaf,j);
			gtk_tree_remove_item(tree_selecttree,tree_selectitem);
			gtk_tree_item_set_subtree(GTK_TREE_ITEM(leaf),yq_readzu(tnode));
		}		
	}
	if (z+n==1)
		gtk_tree_select_child(tree_selectuptree, tree_selecttree->tree_owner);
	else
		gtk_tree_select_item(tree_selecttree,k);  
}

void
toolbar_add(GtkWidget *widget, gpointer data)
{
if (tree_selectzuname[0]=='\0') return;
 if (yqlist.type==LIST_DETAILS)
 {
  yq_set_list_type(LIST_NOTEBOOK); 
 }
 else
 {
 nb_changed=1;
 gtk_entry_set_text(GTK_ENTRY(nb_1_1),"");
 gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(nb_1_2)->entry),"");
 gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(nb_1_3)->entry), "");
 gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON(nb_1_4), 0); 
gtk_entry_set_text(GTK_ENTRY(nb_1_5),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_6),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_7),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_8),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_9),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_10),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_11),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_12),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_13),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_14),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_15),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_16),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_17),"");
gtk_entry_set_text(GTK_ENTRY(nb_1_18),"");

gtk_entry_set_text(GTK_ENTRY(nb_2_1),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_2),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_3),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_4),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_5),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_6),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_7),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_8),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_9),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_10),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_11),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_12),"");
gtk_entry_set_text(GTK_ENTRY(nb_2_13),"");

gtk_editable_delete_text (GTK_EDITABLE (nb_3_1), 0, -1);
gtk_editable_delete_text (GTK_EDITABLE (nb_3_2), 0, -1);
nb_changed=0;
}
nb_isadd=1;
nb_setchanged(widget,NULL);
}

void 
toolbar_zu(GtkWidget *widget, gpointer data)
{
	gint z;
	gchar tz[260];

	if (tree_selectzuname[0]=='\0') return;
	yq_cfg_read_int(cfgfile,tree_selectzuname,"z",&z);
	sprintf(tz,"%s_%d",tree_selectzuname,z+1);
	InputName (":","");
	if (!yesnoreturn) return;
	if (sFilename[0]=='\0')
	{
		Popup("Ϊ!");
		return;
	}
	yq_cfg_write_int(cfgfile,tree_selectzuname,"z",z+1); 
	yq_cfg_write_string(cfgfile,tz,"n",sFilename);
	yq_cfg_write_int(cfgfile,tz,"z",0);             
	yq_cfg_write_int(cfgfile,tz,"a",0);             
	toolbar_addzu();
}

void 
toolbar_addzu()
{
	GtkWidget *leaf;
	gint z;
	gchar tz[260],*zuname;
	tree_node *tnode;

	yq_cfg_read_int(cfgfile,tree_selectzuname,"z",&z);
	sprintf(tz,"%s_%d",tree_selectzuname,z);
	yq_cfg_read_string(cfgfile,tz,"n",&zuname);
	leaf=yq_createleaf(zuname,ZU_CLOSE); 
	g_free(zuname);
	tnode = g_malloc(sizeof(tree_node));
	tnode -> cfg = cfgfile;
	tnode->root_leaf=tree_selectrootleaf;
	strcpy(tnode -> nodename, tz);		

	if (tree_selectiszu)
		open_zu(tree_selectzuname);
	else
		gtk_tree_select_child(tree_selectuptree,tree_selecttree->tree_owner );
	gtk_clist_select_row(GTK_CLIST(yqlist.list),z-1,0);   
	if  (!GTK_TREE_ITEM(tree_selectitem)->subtree) 
		gtk_tree_item_set_subtree(GTK_TREE_ITEM(tree_selectitem),yq_createnulltree());
	if (!GTK_TREE_ITEM(tree_selectitem)->expanded)
		gtk_tree_item_expand(GTK_TREE_ITEM(tree_selectitem));
	gtk_tree_insert(GTK_TREE(GTK_TREE_ITEM(tree_selectitem)->subtree),leaf,z-1);  
	tnode->attree=GTK_TREE(GTK_TREE_ITEM(tree_selectitem)->subtree);
	tnode->uptree=tree_selecttree; 		
	gtk_signal_connect(GTK_OBJECT(leaf), "expand",
				GTK_SIGNAL_FUNC(zu_expanded),tnode);
	gtk_signal_connect(GTK_OBJECT(leaf), "collapse",
				GTK_SIGNAL_FUNC(zu_collapsed),tnode);
	gtk_signal_connect(GTK_OBJECT(leaf), "select",
			GTK_SIGNAL_FUNC(zu_selected),tnode);

	gtk_tree_item_set_subtree(GTK_TREE_ITEM(leaf),yq_readzu(tnode)); 
  
}

void
toolbar_open(GtkWidget *widget, gpointer data)
{
GetFilename ("YQļ");
if (sFilename[0]!='\0') yq_readfile(widget,sFilename); 
}

void
toolbar_rename(GtkWidget *widget, gpointer data)
{
gchar *ab,tz[256];
if (tree_selectzuname[0]=='\0') return;
if (!tree_selectiszu) return;
  yq_cfg_read_string(cfgfile,tree_selectzuname,"n",&ab);
  sprintf(tz," \"%s\" Ϊ:",ab);
  InputName (tz,ab);
  if (!yesnoreturn) return;
  strcpy(tz,ab);
  g_free(ab);
  if (sFilename[0]=='\0')
   {
    Popup("Ϊ!");
    return;
    }
  if (!strcmp(sFilename,tz))
   {
    Popup("ͬ!");
    return;
    }
   tree_set_text(GTK_TREE_ITEM(tree_selectitem),sFilename);
   yq_cfg_write_string(cfgfile,tree_selectzuname,"n",sFilename);
}

void
toolbar_new(GtkWidget *widget, gpointer data)
{
	struct stat st;
	FILE *file;

	GetFilename ("½YQļ");
	if (sFilename[0]=='\0') return;
	if (!stat(sFilename, &st))
	{
	Areyousure("ļѾ,ȷʵҪ滻?");
	if (!yesnoreturn) return;
	}
	create_yqfile(sFilename);
	yq_readfile(widget,sFilename);
}



void
toolbar_copy(GtkWidget *widget, gpointer data)
{
	if (tree_selectzuname[0]=='\0') return;
	nowincopy.cfg=cfgfile;
	nowincopy.iszu=tree_selectiszu;
	strcpy(nowincopy.zuname,tree_selectzuname);
	if (!tree_selectiszu)
		strcpy(nowincopy.jiluname,tree_selectjilu);
}

void toolbar_copyzu(gchar *zuname1,gchar *zuname2)
{
	gchar *ab,tz[260],tz2[260];
	gint i,z;
	
	yq_cfg_read_string(nowincopy.cfg,zuname2,"n",&ab);
	yq_cfg_write_string(cfgfile,zuname1,"n",ab);
	g_free(ab);
	yq_cfg_read_int(nowincopy.cfg,zuname2,"a",&z);
	yq_cfg_write_int(cfgfile,zuname1,"a",z);             
	for (i=1;i<=z;i++)
	{
		sprintf(tz,"%d",i);
		yq_cfg_read_string(nowincopy.cfg,zuname2,tz,&ab);
		yq_cfg_write_string(cfgfile,zuname1,tz,ab);
		g_free(ab);
	}
	yq_cfg_read_int(nowincopy.cfg,zuname2,"z",&z);
	yq_cfg_write_int(cfgfile,zuname1,"z",z);             	
	for (i=1;i<=z;i++)
	{
		sprintf(tz,"%s_%d",zuname1,i);
		sprintf(tz2,"%s_%d",zuname2,i);
		toolbar_copyzu(tz,tz2);
	}
}

void
toolbar_paste(GtkWidget *widget, gpointer data)
{
	gchar *ab,tz[256];
	gint z;
	
	if (nowincopy.zuname[0]=='\0') return;
	if (tree_selectzuname[0]=='\0') return;
	if (nowincopy.iszu)
	{
		if (!yq_cfg_read_int(nowincopy.cfg,nowincopy.zuname,"a",&z)) return;
		yq_cfg_read_int(cfgfile,tree_selectzuname,"z",&z);
		sprintf(tz,"%s_%d",tree_selectzuname,z+1);
		toolbar_copyzu(tz,nowincopy.zuname);			
		yq_cfg_write_int(cfgfile,tree_selectzuname,"z",z+1); 
		toolbar_addzu();
	} else
	{
		if (!yq_cfg_read_string(nowincopy.cfg,nowincopy.zuname,nowincopy.jiluname,&ab))
			return;
		toolbar_addjilu(ab);
		g_free(ab);	
	}

}






