#include <gtk/gtk.h>
#include "configfile.h"


GtkWidget *menu_file_new,*menu_file_open,*menu_file_openold,*menu_file_close,*menu_file_saveas,*menu_file_exit,*menu_edit_cut,*menu_edit_copy,*menu_edit_paste,*menu_jilu_add,*menu_jilu_remove,*menu_jilu_save,*menu_jilu_saveadd,*menu_jilu_cancel,*menu_jilu_zu,*menu_jilu_rename,*menu_tool_option;

extern ConfigFile *rccfgfile;


gint CloseAppWindow (GtkWidget *widget, gpointer *data);
void kk (GtkWidget *widget, gpointer data);
void yq_readfile(GtkWidget *widget, gpointer file_name);
void file_close();
void file_saveas(GtkWidget *widget, gpointer data);

void toolbar_save(GtkWidget *widget, gpointer data);
void toolbar_cancel(GtkWidget *widget, gpointer data);
void toolbar_remove(GtkWidget *widget, gpointer data);
void toolbar_add(GtkWidget *widget, gpointer data);
void toolbar_saveadd(GtkWidget *widget, gpointer data);
void toolbar_zu(GtkWidget *widget, gpointer data);
void toolbar_open(GtkWidget *widget, gpointer data);
void toolbar_rename(GtkWidget *widget, gpointer data);
void toolbar_new(GtkWidget *widget, gpointer data);
void toolbar_copy(GtkWidget *widget, gpointer data);
void toolbar_paste(GtkWidget *widget, gpointer data);
void show_config_window();
void show_about_window();

 


GtkWidget *CreateBarSubMenu (GtkWidget *menubar, char *szName);
GtkWidget *CreateSubMenu (GtkWidget *menu, char *szName);
GtkWidget *CreateMenuItem (GtkWidget *menu, 
                           char *szName, 
                           GtkAccelGroup *accel,
			   guint key,
			   guint mods,
                           GtkSignalFunc func,
                           gpointer data);
GtkWidget *CreateMenuCheck (GtkWidget *menu, 
                            char *szName, 
                            GtkSignalFunc func, 
                            gpointer data);
GtkWidget *CreateMenuRadio (GtkWidget *menu, 
                            char *szName, 
                            GSList **group,
                            GtkSignalFunc func, 
                            gpointer data);

void
createmenu (GtkWidget *win_main,GtkWidget *main_vbox)
{
    GtkWidget *menubar;
    GtkWidget *menu;
    GtkWidget *submenu;
    GtkWidget *menuitem;
    GtkAccelGroup *accel;
    GSList *groupview = NULL;    
    GSList *grouppailie1 = NULL;
    GSList *grouppailie2 = NULL;    
    gint i,a;
    gchar *ab,ti[4];

    accel = gtk_accel_group_new ();
    gtk_accel_group_attach (accel, GTK_OBJECT (win_main));
    menubar = gtk_menu_bar_new ();
    gtk_box_pack_start(GTK_BOX (main_vbox), menubar, FALSE, TRUE, 0);
    gtk_widget_show(menubar);
    menu = CreateBarSubMenu (menubar, "¼");

    menu_file_new = CreateMenuItem (menu, "½", accel,'N',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (toolbar_new), NULL);

    menu_file_open = CreateMenuItem (menu, "", accel,'O',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (toolbar_open), NULL);

    menu_file_openold = CreateSubMenu (menu, "");
    
    yq_cfg_read_int(rccfgfile,"file","a",&a);
    for (i=1;i<=a;i++)
    {
    	sprintf(ti,"%d",i);
    	yq_cfg_read_string(rccfgfile,"file",ti,&ab);
	menuitem = CreateMenuItem (menu_file_openold, ab, NULL,0,0, 
                     GTK_SIGNAL_FUNC (yq_readfile),g_strdup(ab));
        g_free(ab);              
    }
    menu_file_close = CreateMenuItem (menu, "ر", NULL,0,0, 
                     GTK_SIGNAL_FUNC (file_close), NULL);

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menu_file_saveas = CreateMenuItem (menu, "Ϊ...", NULL,0,0, 
                     GTK_SIGNAL_FUNC (file_saveas), NULL);

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    submenu = CreateSubMenu (menu, "");

    menuitem = CreateMenuItem (submenu, "ıļ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "name");
    menuitem = CreateMenuItem (submenu, "Զŷָıļ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "name");

    submenu = CreateSubMenu (menu, "");

    menuitem = CreateMenuItem (submenu, "ıļ", NULL,0,0,
                     GTK_SIGNAL_FUNC (kk), "name");
    menuitem = CreateMenuItem (submenu, "Զŷָıļ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "name");
    menuitem = CreateMenuItem (submenu, "ıļ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "name");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "ӡ", accel,'P',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (kk), "print");
    menuitem = CreateMenuItem (menu, "ӡ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "printset");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "Ƴ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "del mark");
    menuitem = CreateMenuItem (menu, "Ƴȫ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "del all mark");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "newload");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "profece");
		     
    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menu_file_exit = CreateMenuItem (menu, "˳",accel,'X', GDK_MOD1_MASK,
                     GTK_SIGNAL_FUNC (CloseAppWindow),NULL);

    /* -----------------
       --- Edit menu ---
       ----------------- */
    menu = CreateBarSubMenu (menubar, "༩");

    menu_edit_cut = CreateMenuItem (menu, "", accel,'X',GDK_CONTROL_MASK,
                     GTK_SIGNAL_FUNC (kk), "cut");

    menu_edit_copy = CreateMenuItem (menu, "", accel,'C',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (toolbar_copy), NULL);

    menu_edit_paste = CreateMenuItem (menu, "ճ", accel,'V',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (toolbar_paste), NULL);

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "ȫѡ", accel,'A',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (kk), "select all");
    menuitem = CreateMenuItem (menu, "ѡ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "select else");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "", accel,'F',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (kk), "search");
    menuitem = CreateMenuItem (menu, "滻", accel,'H',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (kk), "instead");

    
    menu = CreateBarSubMenu (menubar, "¼");
    
    menu_jilu_add = CreateMenuItem (menu, "¼¼", NULL,0,0, 
                     GTK_SIGNAL_FUNC (toolbar_add), NULL);
    menu_jilu_remove = CreateMenuItem (menu, "ɾ",NULL,0,0, 
                     GTK_SIGNAL_FUNC (toolbar_remove), NULL);

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menu_jilu_save = CreateMenuItem (menu, "", accel,'S',GDK_CONTROL_MASK, 
                     GTK_SIGNAL_FUNC (toolbar_save), NULL);
    menu_jilu_saveadd = CreateMenuItem (menu, "沢", NULL,0,0, 
                     GTK_SIGNAL_FUNC (toolbar_saveadd), NULL);
    menu_jilu_cancel = CreateMenuItem (menu, "ȡ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (toolbar_cancel), NULL);

    gtk_widget_set_sensitive(menu_jilu_save,0);
    gtk_widget_set_sensitive(menu_jilu_saveadd,0);
    gtk_widget_set_sensitive(menu_jilu_cancel,0);                       

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "ѯ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "find");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menu_jilu_zu = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (toolbar_zu), NULL);
    
    menu_jilu_rename = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (toolbar_rename), NULL);
    
    menu = CreateBarSubMenu (menubar, "ͼ");
    
    menuitem = CreateMenuItem (menu, "Զ幤", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "search");
    menuitem = CreateMenuItem (menu, "״̬", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "search");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuRadio (menu,"ͼ", &groupview, GTK_SIGNAL_FUNC (kk), "big ico");
    menuitem = CreateMenuRadio (menu,"Сͼ", &groupview, GTK_SIGNAL_FUNC (kk), "small ico");
    menuitem = CreateMenuRadio (menu,"б", &groupview, GTK_SIGNAL_FUNC (kk), "biao");
    menuitem = CreateMenuRadio (menu,"ϸ", &groupview, GTK_SIGNAL_FUNC (kk), "xian");


    menuitem = CreateMenuItem (menu, "ҳʾ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "view");
    
    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    submenu = CreateSubMenu (menu, "зʽ");
    menuitem = CreateMenuRadio (submenu,"", &grouppailie1, GTK_SIGNAL_FUNC (kk), "big ico");
    menuitem = CreateMenuRadio (submenu,"", &grouppailie1, GTK_SIGNAL_FUNC (kk), "small ico");
    menuitem = CreateMenuRadio (submenu,"ƶ绰", &grouppailie1, GTK_SIGNAL_FUNC (kk), "biao");
    menuitem = CreateMenuRadio (submenu,"סլ绰", &grouppailie1, GTK_SIGNAL_FUNC (kk), "xian");

    menuitem = CreateMenuItem (submenu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuRadio (submenu,"", &grouppailie2, GTK_SIGNAL_FUNC (kk), "biao");
    menuitem = CreateMenuRadio (submenu,"ݼ", &grouppailie2, GTK_SIGNAL_FUNC (kk), "xian");

    menuitem = CreateMenuItem (menu, "ж", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "dq");

    menuitem = CreateMenuItem (menu, "ˢ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "refeau");
		     


    menu = CreateBarSubMenu (menubar, "");

    menuitem = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "password");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    submenu = CreateSubMenu (menu, "¼վ");

    menuitem = CreateMenuItem (submenu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "laji");
		     
    menuitem = CreateMenuItem (submenu, "ԭ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "laji");
    menuitem = CreateMenuItem (submenu, "ջվ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "laji");
    menuitem = CreateMenuItem (submenu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "laji");
    menuitem = CreateMenuItem (submenu, "ر", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "laji");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menuitem = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "li");
    menuitem = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (kk), "birthday");

    menuitem = CreateMenuItem (menu, NULL, NULL,0,0,NULL, NULL);

    menu_tool_option = CreateMenuItem (menu, "ѡ", NULL,0,0, 
                     GTK_SIGNAL_FUNC (show_config_window), NULL);
		     

    /* ---------------------
       --- Help sub menu ---
       --------------------- */
    menu = CreateBarSubMenu (menubar, "");

    menuitem = CreateMenuItem (menu, "", NULL,0,0, 
                     GTK_SIGNAL_FUNC (show_about_window), NULL);               
}


